unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, FileCtrl,
  ExtCtrls, Buttons, StdCtrls, EditBtn;

type

  { TForm1 }

  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    DirectoryEdit1: TDirectoryEdit;
    FileListBox1: TFileListBox;
    Label1: TLabel;
    Panel1: TPanel;
    ScrollBox1: TScrollBox;
    procedure BitBtn1Click(Sender: TObject);
    procedure DirectoryEdit1AcceptDirectory(Sender: TObject; var Value: String);
    procedure FormCreate(Sender: TObject);
    procedure ScrollBox1Resize(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.BitBtn1Click(Sender: TObject);
var
  i,px,py:integer;
  NewPanel:TPanel;
  NewImage:TImage;
  NewLabel:TLabel;
begin
  px:=0;
  py:=0;
  // Die FilstList Box durchgehen
  for i:=0 to FileListBox1.Items.Count-1 do begin
    // Bei 100 aufhören, kann auskomentiert werden
    if i = 100 then exit;
    NewPanel:=TPanel.Create(ScrollBox1);
    NewPanel.Parent:=ScrollBox1;
    NewPanel.Left:=px;
    NewPanel.Top:=py;
      // Eine Image Komponente erstellen und Konfiguieren.
      NewImage:=TImage.Create(NewPanel);
      NewImage.Picture.LoadFromFile(FileListBox1.Directory+DirectorySeparator+FileListBox1.Items[i]);
      NewImage.Parent:=NewPanel;
      NewImage.Left:=0;
      NewImage.Top:=0;
      // Ein Label erstellen und Konfiguieren
      NewLabel:=TLabel.Create(NewPanel);
      NewLabel.Parent:=NewPanel;
      NewLabel.AutoSize:=False;
      NewLabel.Caption:=FileListBox1.Items[i];
      NewLabel.Left:=0;
      NewLabel.Top:=NewImage.Height+2;
      NewLabel.Width:=NewImage.Width;
      NewLabel.Height:=20;
    NewPanel.Width:=NewImage.Width;
    NewPanel.Height:=NewImage.Height+NewLabel.Height;
    // Für einen Automatischen Zeilenumbruch
    if px+NewPanel.Width+5 >=ScrollBox1.Width-NewPanel.Width then begin
     px:=0;
     py:=py+NewPanel.Height+5;
    end
    else
      px:=px+NewPanel.Width+5;
  end;
end;

procedure TForm1.DirectoryEdit1AcceptDirectory(Sender: TObject;
  var Value: String);
begin
    FileListBox1.Directory:=Value;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  DirectoryEdit1.Directory:=FileListBox1.Directory;
end;

procedure TForm1.ScrollBox1Resize(Sender: TObject);
var
  px,py,i:Integer;
  Panel:TPanel;
begin
  px:=0; py:=0;
  for i:=0 to ScrollBox1.ComponentCount-1 do begin
    Panel:=ScrollBox1.Components[i] as TPanel;
    Panel.Left:=px;
    Panel.Top:=py;
    if px+Panel.Width >=ScrollBox1.Width-Panel.Width then begin
      px:=0;
      py:=py+Panel.Height;
    end
    else
      px:=px+Panel.Width;
  end;

end;

end.

